Index: trunk/Cocoa/Pester/Source/NJRDateFormatter.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRDateFormatter.m	(revision 47)
+++ trunk/Cocoa/Pester/Source/NJRDateFormatter.m	(revision 49)
@@ -143,5 +143,6 @@
             [(NSMutableDictionary *)alteredLocale setObject:
                 [NSArray arrayWithObjects: stringByRemovingSurroundingWhitespace(am),
-                    stringByRemovingSurroundingWhitespace(pm)] forKey: NSAMPMDesignation];
+                    stringByRemovingSurroundingWhitespace(pm), nil]
+                                                     forKey: NSAMPMDesignation];
             [paddedFormat release];
         } else {
Index: trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser
===================================================================
--- trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 47)
+++ trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 49)
@@ -18,15 +18,15 @@
 		);
 		perUserDictionary = {
-			PBXPerProjectTemplateStateSaveDate = 58614289;
-			"PBXTemplateGeometry-F5CA7ECB015C094F0DCA290F" = {
-				ContentSize = "{668, 621}";
+			PBXPerProjectTemplateStateSaveDate = 58758807;
+			"PBXTemplateGeometry-F5CA7EC8015C06940DCA290F" = {
+				ContentSize = "{705, 569}";
 				LeftSlideOut = {
 					Collapsed = NO;
-					Frame = "{{0, 0}, {668, 621}}";
+					Frame = "{{0, 0}, {705, 569}}";
 					Split0 = {
 						Collapsed = NO;
-						Frame = "{{0, 0}, {668, 621}}";
+						Frame = "{{0, 0}, {705, 569}}";
 						Split0 = {
-							Frame = "{{0, 0}, {668, 621}}";
+							Frame = "{{0, 0}, {705, 569}}";
 						};
 						SplitCount = 1;
@@ -67,14 +67,14 @@
 						};
 						Tab1 = {
-							Frame = "{{0, 0}, {664, 208}}";
+							Frame = "{{0, 0}, {522, 208}}";
 							LauncherConfigVersion = 3;
 							Runner = {
-								Frame = "{{0, 0}, {664, 208}}";
+								Frame = "{{0, 0}, {522, 208}}";
 							};
 						};
 						Tab2 = {
-							BuildMessageFrame = "{{0, 0}, {666, 43}}";
-							BuildTranscriptFrame = "{{0, 52}, {666, 0}}";
-							Frame = "{{0, 0}, {664, 50}}";
+							BuildMessageFrame = "{{0, 0}, {809, 410}}";
+							BuildTranscriptFrame = "{{0, 419}, {809, 119}}";
+							Frame = "{{0, 0}, {807, 536}}";
 						};
 						Tab3 = {
@@ -86,10 +86,10 @@
 					SplitCount = 1;
 					Tab0 = {
-						Frame = "{{0, 0}, {313, 531}}";
+						Frame = "{{0, 0}, {300, 533}}";
 						GroupTreeTableConfiguration = (
 							TargetStatusColumn,
 							18,
 							MainColumn,
-							280,
+							267,
 						);
 					};
@@ -115,4 +115,125 @@
 					};
 					Tab3 = {
+						Frame = "{{0, 0}, {222, 536}}";
+						TargetTableConfiguration = (
+							ActiveObject,
+							16,
+							ObjectNames,
+							202.296,
+						);
+					};
+					Tab4 = {
+						BreakpointsTreeTableConfiguration = (
+							breakpointColumn,
+							197,
+							enabledColumn,
+							31,
+						);
+						Frame = "{{0, 0}, {250, 528}}";
+					};
+					TabCount = 5;
+					TabsVisible = NO;
+				};
+				StatusViewVisible = NO;
+				Template = F5CA7EC8015C06940DCA290F;
+				ToolbarVisible = YES;
+				WindowLocation = "{11, 351}";
+			};
+			"PBXTemplateGeometry-F5CA7ECB015C094F0DCA290F" = {
+				ContentSize = "{668, 621}";
+				LeftSlideOut = {
+					Collapsed = NO;
+					Frame = "{{0, 0}, {668, 621}}";
+					Split0 = {
+						Collapsed = NO;
+						Frame = "{{0, 0}, {668, 621}}";
+						Split0 = {
+							Frame = "{{0, 0}, {668, 621}}";
+						};
+						SplitCount = 1;
+						Tab0 = {
+							Debugger = {
+								Collapsed = NO;
+								Frame = "{{0, 0}, {484, 208}}";
+								Split0 = {
+									Frame = "{{0, 24}, {484, 184}}";
+									Split0 = {
+										Frame = "{{0, 0}, {236, 184}}";
+									};
+									Split1 = {
+										DebugVariablesTableConfiguration = (
+											Name,
+											123,
+											Value,
+											85,
+											Summary,
+											62.123,
+										);
+										Frame = "{{245, 0}, {239, 184}}";
+									};
+									SplitCount = 2;
+								};
+								SplitCount = 1;
+								Tab0 = {
+									Frame = "{{0, 0}, {100, 50}}";
+								};
+								Tab1 = {
+									Frame = "{{0, 0}, {100, 50}}";
+								};
+								TabCount = 2;
+								TabsVisible = YES;
+							};
+							Frame = "{{0, 0}, {484, 208}}";
+							LauncherConfigVersion = 7;
+						};
+						Tab1 = {
+							Frame = "{{0, 0}, {664, 208}}";
+							LauncherConfigVersion = 3;
+							Runner = {
+								Frame = "{{0, 0}, {664, 208}}";
+							};
+						};
+						Tab2 = {
+							BuildMessageFrame = "{{0, 0}, {666, 43}}";
+							BuildTranscriptFrame = "{{0, 52}, {666, 0}}";
+							Frame = "{{0, 0}, {664, 50}}";
+						};
+						Tab3 = {
+							Frame = "{{0, 0}, {612, 295}}";
+						};
+						TabCount = 4;
+						TabsVisible = NO;
+					};
+					SplitCount = 1;
+					Tab0 = {
+						Frame = "{{0, 0}, {313, 531}}";
+						GroupTreeTableConfiguration = (
+							TargetStatusColumn,
+							18,
+							MainColumn,
+							280,
+						);
+					};
+					Tab1 = {
+						ClassesFrame = "{{0, 0}, {280, 398}}";
+						ClassesTreeTableConfiguration = (
+							PBXBookColumnIdentifier,
+							20,
+							PBXClassColumnIdentifier,
+							237,
+						);
+						Frame = "{{0, 0}, {278, 659}}";
+						MembersFrame = "{{0, 407}, {280, 252}}";
+						MembersTreeTableConfiguration = (
+							PBXBookColumnIdentifier,
+							20,
+							PBXMethodColumnIdentifier,
+							236,
+						);
+					};
+					Tab2 = {
+						Frame = "{{0, 0}, {200, 100}}";
+					};
+					Tab3 = {
 						Frame = "{{0, 0}, {200, 557}}";
 						TargetTableConfiguration = (
@@ -138,5 +259,128 @@
 				Template = F5CA7ECB015C094F0DCA290F;
 				ToolbarVisible = NO;
-				WindowLocation = "{390, 201}";
+				WindowLocation = "{48, 349}";
+			};
+			"PBXTemplateGeometry-F5CA7ECC015C09990DCA290F" = {
+				ContentSize = "{956, 601}";
+				LeftSlideOut = {
+					ActiveTab = 4;
+					Collapsed = NO;
+					Frame = "{{0, 23}, {956, 578}}";
+					Split0 = {
+						ActiveTab = 0;
+						Collapsed = NO;
+						Frame = "{{274, 0}, {682, 578}}";
+						Split0 = {
+							Frame = "{{0, 273}, {682, 305}}";
+						};
+						SplitCount = 1;
+						Tab0 = {
+							Debugger = {
+								Collapsed = NO;
+								Frame = "{{0, 0}, {682, 267}}";
+								Split0 = {
+									Frame = "{{0, 24}, {682, 243}}";
+									Split0 = {
+										Frame = "{{0, 0}, {328, 243}}";
+									};
+									Split1 = {
+										DebugVariablesTableConfiguration = (
+											Name,
+											93.80298,
+											Value,
+											116.074,
+											Summary,
+											109.123,
+										);
+										Frame = "{{337, 0}, {345, 243}}";
+									};
+									SplitCount = 2;
+								};
+								SplitCount = 1;
+								Tab0 = {
+									Frame = "{{0, 0}, {100, 50}}";
+								};
+								Tab1 = {
+									Frame = "{{0, 0}, {100, 50}}";
+								};
+								TabCount = 2;
+								TabsVisible = YES;
+							};
+							Frame = "{{0, 0}, {682, 267}}";
+							LauncherConfigVersion = 7;
+						};
+						Tab1 = {
+							Frame = "{{0, 0}, {664, 208}}";
+							LauncherConfigVersion = 3;
+							Runner = {
+								Frame = "{{0, 0}, {664, 208}}";
+							};
+						};
+						Tab2 = {
+							BuildMessageFrame = "{{0, 0}, {666, 43}}";
+							BuildTranscriptFrame = "{{0, 52}, {666, 0}}";
+							Frame = "{{0, 0}, {664, 50}}";
+						};
+						Tab3 = {
+							Frame = "{{0, 0}, {612, 295}}";
+						};
+						TabCount = 4;
+						TabsVisible = NO;
+					};
+					SplitCount = 1;
+					Tab0 = {
+						Frame = "{{0, 0}, {313, 531}}";
+						GroupTreeTableConfiguration = (
+							TargetStatusColumn,
+							18,
+							MainColumn,
+							280,
+						);
+					};
+					Tab1 = {
+						ClassesFrame = "{{0, 0}, {280, 398}}";
+						ClassesTreeTableConfiguration = (
+							PBXBookColumnIdentifier,
+							20,
+							PBXClassColumnIdentifier,
+							237,
+						);
+						Frame = "{{0, 0}, {278, 659}}";
+						MembersFrame = "{{0, 407}, {280, 252}}";
+						MembersTreeTableConfiguration = (
+							PBXBookColumnIdentifier,
+							20,
+							PBXMethodColumnIdentifier,
+							236,
+						);
+					};
+					Tab2 = {
+						Frame = "{{0, 0}, {200, 100}}";
+					};
+					Tab3 = {
+						Frame = "{{0, 0}, {200, 557}}";
+						TargetTableConfiguration = (
+							ActiveObject,
+							16,
+							ObjectNames,
+							202.296,
+						);
+					};
+					Tab4 = {
+						BreakpointsTreeTableConfiguration = (
+							breakpointColumn,
+							197,
+							enabledColumn,
+							31,
+						);
+						Frame = "{{0, 0}, {250, 578}}";
+					};
+					TabCount = 5;
+					TabsVisible = YES;
+				};
+				StatusViewVisible = YES;
+				Template = F5CA7ECC015C09990DCA290F;
+				ToolbarVisible = YES;
+				WindowLocation = "{79, 361}";
 			};
 			PBXWorkspaceContents = (
@@ -215,13 +459,7 @@
 						Split0 = {
 							Split0 = {
-								NavContent0 = {
-									bookmark = F562F80B037E5D2101AEEDB1;
-									history = (
-										F5B163A5037E543A01AEEDB1,
-									);
-								};
 								NavCount = 1;
 								NavGeometry0 = {
-									Frame = "{{0, 0}, {668, 621}}";
+									Frame = "{{0, 0}, {618, 150}}";
 									NavBarVisible = YES;
 								};
@@ -256,7 +494,58 @@
 						Split0 = {
 							Split0 = {
+								NavContent0 = {
+									bookmark = F562F814037E7F6101AEEDB1;
+									history = (
+										F562F813037E7F6101AEEDB1,
+									);
+								};
 								NavCount = 1;
 								NavGeometry0 = {
-									Frame = "{{0, 0}, {618, 150}}";
+									Frame = "{{0, 0}, {668, 621}}";
+									NavBarVisible = YES;
+								};
+							};
+							SplitCount = 1;
+							Tab0 = {
+								Debugger = {
+									Split0 = {
+										SplitCount = 2;
+									};
+									SplitCount = 1;
+									TabCount = 2;
+								};
+								LauncherConfigVersion = 7;
+							};
+							Tab1 = {
+								LauncherConfigVersion = 3;
+								Runner = {
+								};
+							};
+							TabCount = 4;
+						};
+						SplitCount = 1;
+						Tab1 = {
+							OptionsSetName = "Hierarchy, all classes";
+						};
+						TabCount = 5;
+					};
+				},
+				{
+					LeftSlideOut = {
+						Split0 = {
+							Split0 = {
+								NavContent0 = {
+									bookmark = F562F818037E7F6101AEEDB1;
+									history = (
+										F562F815037E7F6101AEEDB1,
+										F562F816037E7F6101AEEDB1,
+									);
+									prevStack = (
+										F562F817037E7F6101AEEDB1,
+									);
+								};
+								NavCount = 1;
+								NavGeometry0 = {
+									Frame = "{{0, 0}, {682, 305}}";
 									NavBarVisible = YES;
 								};
@@ -534,4 +823,126 @@
 				},
 				{
+					ContentSize = "{618, 257}";
+					LeftSlideOut = {
+						Collapsed = NO;
+						Frame = "{{0, 23}, {618, 234}}";
+						Split0 = {
+							ActiveTab = 2;
+							Collapsed = YES;
+							Frame = "{{0, 0}, {618, 234}}";
+							Split0 = {
+								Frame = "{{1e+06, 1e+06}, {618, 0}}";
+							};
+							SplitCount = 1;
+							Tab0 = {
+								Debugger = {
+									Collapsed = NO;
+									Frame = "{{0, 0}, {952, 321}}";
+									Split0 = {
+										Frame = "{{0, 24}, {952, 297}}";
+										Split0 = {
+											Frame = "{{0, 0}, {468, 297}}";
+										};
+										Split1 = {
+											DebugVariablesTableConfiguration = (
+												Name,
+												126.803,
+												Value,
+												150.074,
+												Summary,
+												172.123,
+											);
+											Frame = "{{477, 0}, {475, 297}}";
+										};
+										SplitCount = 2;
+									};
+									SplitCount = 1;
+									Tab0 = {
+										Frame = "{{0, 0}, {100, 50}}";
+									};
+									Tab1 = {
+										Frame = "{{0, 0}, {100, 50}}";
+									};
+									TabCount = 2;
+									TabsVisible = YES;
+								};
+								Frame = "{{0, 0}, {952, 321}}";
+								LauncherConfigVersion = 7;
+							};
+							Tab1 = {
+								Frame = "{{0, 0}, {781, 452}}";
+								LauncherConfigVersion = 3;
+								Runner = {
+									Frame = "{{0, 0}, {781, 452}}";
+								};
+							};
+							Tab2 = {
+								BuildMessageFrame = "{{0, 0}, {620, 122}}";
+								BuildTranscriptFrame = "{{0, 131}, {620, 99}}";
+								Frame = "{{0, 0}, {618, 228}}";
+							};
+							Tab3 = {
+								Frame = "{{0, 0}, {612, 295}}";
+							};
+							TabCount = 4;
+							TabsVisible = NO;
+						};
+						SplitCount = 1;
+						Tab0 = {
+							Frame = "{{0, 0}, {300, 533}}";
+							GroupTreeTableConfiguration = (
+								TargetStatusColumn,
+								18,
+								MainColumn,
+								267,
+							);
+						};
+						Tab1 = {
+							ClassesFrame = "{{0, 0}, {280, 398}}";
+							ClassesTreeTableConfiguration = (
+								PBXBookColumnIdentifier,
+								20,
+								PBXClassColumnIdentifier,
+								237,
+							);
+							Frame = "{{0, 0}, {278, 659}}";
+							MembersFrame = "{{0, 407}, {280, 252}}";
+							MembersTreeTableConfiguration = (
+								PBXBookColumnIdentifier,
+								20,
+								PBXMethodColumnIdentifier,
+								236,
+							);
+						};
+						Tab2 = {
+							Frame = "{{0, 0}, {200, 100}}";
+						};
+						Tab3 = {
+							Frame = "{{0, 0}, {200, 100}}";
+							TargetTableConfiguration = (
+								ActiveObject,
+								16,
+								ObjectNames,
+								202.296,
+							);
+						};
+						Tab4 = {
+							BreakpointsTreeTableConfiguration = (
+								breakpointColumn,
+								197,
+								enabledColumn,
+								31,
+							);
+							Frame = "{{0, 0}, {250, 100}}";
+						};
+						TabCount = 5;
+						TabsVisible = NO;
+					};
+					StatusViewVisible = YES;
+					Template = F5314676015831810DCA290F;
+					ToolbarVisible = YES;
+					WindowLocation = "{427, 271}";
+				},
+				{
 					ContentSize = "{668, 621}";
 					LeftSlideOut = {
@@ -655,14 +1066,15 @@
 				},
 				{
-					ContentSize = "{618, 257}";
+					ContentSize = "{956, 601}";
 					LeftSlideOut = {
+						ActiveTab = 4;
 						Collapsed = NO;
-						Frame = "{{0, 23}, {618, 234}}";
+						Frame = "{{0, 23}, {956, 578}}";
 						Split0 = {
-							ActiveTab = 2;
-							Collapsed = YES;
-							Frame = "{{0, 0}, {618, 234}}";
+							ActiveTab = 0;
+							Collapsed = NO;
+							Frame = "{{274, 0}, {682, 578}}";
 							Split0 = {
-								Frame = "{{1e+06, 1e+06}, {618, 0}}";
+								Frame = "{{0, 273}, {682, 305}}";
 							};
 							SplitCount = 1;
@@ -670,20 +1082,20 @@
 								Debugger = {
 									Collapsed = NO;
-									Frame = "{{0, 0}, {952, 321}}";
+									Frame = "{{0, 0}, {682, 267}}";
 									Split0 = {
-										Frame = "{{0, 24}, {952, 297}}";
+										Frame = "{{0, 24}, {682, 243}}";
 										Split0 = {
-											Frame = "{{0, 0}, {468, 297}}";
+											Frame = "{{0, 0}, {329, 243}}";
 										};
 										Split1 = {
 											DebugVariablesTableConfiguration = (
 												Name,
-												126.803,
+												93.80298,
 												Value,
-												150.074,
+												116.074,
 												Summary,
-												172.123,
+												108.123,
 											);
-											Frame = "{{477, 0}, {475, 297}}";
+											Frame = "{{338, 0}, {344, 243}}";
 										};
 										SplitCount = 2;
@@ -699,18 +1111,18 @@
 									TabsVisible = YES;
 								};
-								Frame = "{{0, 0}, {952, 321}}";
+								Frame = "{{0, 0}, {682, 267}}";
 								LauncherConfigVersion = 7;
 							};
 							Tab1 = {
-								Frame = "{{0, 0}, {781, 452}}";
+								Frame = "{{0, 0}, {664, 208}}";
 								LauncherConfigVersion = 3;
 								Runner = {
-									Frame = "{{0, 0}, {781, 452}}";
+									Frame = "{{0, 0}, {664, 208}}";
 								};
 							};
 							Tab2 = {
-								BuildMessageFrame = "{{0, 0}, {620, 123}}";
-								BuildTranscriptFrame = "{{0, 132}, {620, 98}}";
-								Frame = "{{0, 0}, {618, 228}}";
+								BuildMessageFrame = "{{0, 0}, {666, 43}}";
+								BuildTranscriptFrame = "{{0, 52}, {666, 0}}";
+								Frame = "{{0, 0}, {664, 50}}";
 							};
 							Tab3 = {
@@ -722,10 +1134,10 @@
 						SplitCount = 1;
 						Tab0 = {
-							Frame = "{{0, 0}, {300, 533}}";
+							Frame = "{{0, 0}, {313, 531}}";
 							GroupTreeTableConfiguration = (
 								TargetStatusColumn,
 								18,
 								MainColumn,
-								267,
+								280,
 							);
 						};
@@ -751,5 +1163,5 @@
 						};
 						Tab3 = {
-							Frame = "{{0, 0}, {200, 100}}";
+							Frame = "{{0, 0}, {200, 557}}";
 							TargetTableConfiguration = (
 								ActiveObject,
@@ -766,20 +1178,24 @@
 								31,
 							);
-							Frame = "{{0, 0}, {250, 100}}";
+							Frame = "{{0, 0}, {250, 578}}";
 						};
 						TabCount = 5;
-						TabsVisible = NO;
+						TabsVisible = YES;
 					};
 					StatusViewVisible = YES;
-					Template = F5314676015831810DCA290F;
+					Template = F5CA7ECC015C09990DCA290F;
 					ToolbarVisible = YES;
-					WindowLocation = "{427, 271}";
+					WindowLocation = "{79, 361}";
 				},
 			);
-			PBXWorkspaceStateSaveDate = 58614289;
+			PBXWorkspaceStateSaveDate = 58758807;
 		};
 		perUserProjectItems = {
-			F562F80B037E5D2101AEEDB1 = F562F80B037E5D2101AEEDB1;
-			F5B163A5037E543A01AEEDB1 = F5B163A5037E543A01AEEDB1;
+			F562F813037E7F6101AEEDB1 = F562F813037E7F6101AEEDB1;
+			F562F814037E7F6101AEEDB1 = F562F814037E7F6101AEEDB1;
+			F562F815037E7F6101AEEDB1 = F562F815037E7F6101AEEDB1;
+			F562F816037E7F6101AEEDB1 = F562F816037E7F6101AEEDB1;
+			F562F817037E7F6101AEEDB1 = F562F817037E7F6101AEEDB1;
+			F562F818037E7F6101AEEDB1 = F562F818037E7F6101AEEDB1;
 		};
 		projectwideBuildSettings = {
@@ -860,18 +1276,59 @@
 		vrLoc = 0;
 	};
-	F562F80B037E5D2101AEEDB1 = {
-		fRef = F59DC6FD0354188F01AEEDB1;
-		isa = PBXTextBookmark;
-		name = "NJRDateFormatter.m: initWithDateFormat:allowNaturalLanguage:";
-		rLen = 0;
-		rLoc = 6368;
-		rType = 0;
-		vrLen = 2132;
-		vrLoc = 5663;
-	};
 	F562F810037E79EE01AEEDB1 = {
 		isa = PBXSymbolicBreakpoint;
 		state = 1;
 		symbolName = "-[PSAlarmSetController awakeFromNib]";
+	};
+	F562F813037E7F6101AEEDB1 = {
+		fRef = F59DC6D40353C9E601AEEDB1;
+		isa = PBXBookmark;
+	};
+	F562F814037E7F6101AEEDB1 = {
+		fRef = F59DC6D40353C9E601AEEDB1;
+		isa = PBXTextBookmark;
+		name = "PSAlarmSetController.m: awakeFromNib";
+		rLen = 0;
+		rLoc = 2784;
+		rType = 0;
+		vrLen = 1841;
+		vrLoc = 0;
+	};
+	F562F815037E7F6101AEEDB1 = {
+		fRef = F59DC6D40353C9E601AEEDB1;
+		isa = PBXTextBookmark;
+		name = "PSAlarmSetController.m: awakeFromNib";
+		rLen = 51;
+		rLoc = 3497;
+		rType = 0;
+		vrLen = 1188;
+		vrLoc = 3010;
+	};
+	F562F816037E7F6101AEEDB1 = {
+		fRef = F5F240CC036A877301FE7503;
+		isa = PBXTextBookmark;
+		rLen = 0;
+		rLoc = 71;
+		rType = 1;
+	};
+	F562F817037E7F6101AEEDB1 = {
+		fRef = F59DC6D40353C9E601AEEDB1;
+		isa = PBXTextBookmark;
+		name = "PSAlarmSetController.m: awakeFromNib";
+		rLen = 51;
+		rLoc = 3497;
+		rType = 0;
+		vrLen = 1188;
+		vrLoc = 3010;
+	};
+	F562F818037E7F6101AEEDB1 = {
+		fRef = F5F240CC036A877301FE7503;
+		isa = PBXTextBookmark;
+		name = "NJRQTMediaPopUpButton.m: _addRecentMediaFromAliasesData:";
+		rLen = 0;
+		rLoc = 2850;
+		rType = 0;
+		vrLen = 580;
+		vrLoc = 2437;
 	};
 	F596730D0355CFA301407038 = {
@@ -964,14 +1421,4 @@
 		symbolName = "-[NSException raise]";
 	};
-	F5B163A5037E543A01AEEDB1 = {
-		fRef = F59DC6FD0354188F01AEEDB1;
-		isa = PBXTextBookmark;
-		name = "NJRDateFormatter.m: format:withoutComponent:";
-		rLen = 0;
-		rLoc = 829;
-		rType = 0;
-		vrLen = 2132;
-		vrLoc = 5663;
-	};
 	F5F19881036B90CD01EB0372 = {
 		fRef = F59DC6D40353C9E601AEEDB1;
Index: trunk/Cocoa/Pester/Source/Pester.pbproj/project.pbxproj
===================================================================
--- trunk/Cocoa/Pester/Source/Pester.pbproj/project.pbxproj	(revision 47)
+++ trunk/Cocoa/Pester/Source/Pester.pbproj/project.pbxproj	(revision 49)
@@ -249,5 +249,5 @@
 	<string>Pester</string>
 	<key>CFBundleGetInfoString</key>
-	<string>Pester 1.1a2, © 2002 Nicholas Riley</string>
+	<string>Pester 1.1a3, © 2002 Nicholas Riley</string>
 	<key>CFBundleIconFile</key>
 	<string>Application icon</string>
@@ -261,9 +261,9 @@
 	<string>APPL</string>
 	<key>CFBundleShortVersionString</key>
-	<string>1.1a1</string>
+	<string>1.1a3</string>
 	<key>CFBundleSignature</key>
 	<string>Pstr</string>
 	<key>CFBundleVersion</key>
-	<string>1.1a2</string>
+	<string>1.1a3</string>
 	<key>NSMainNibFile</key>
 	<string>MainMenu</string>
Index: trunk/Cocoa/Pester/Source/VERSION
===================================================================
--- trunk/Cocoa/Pester/Source/VERSION	(revision 47)
+++ trunk/Cocoa/Pester/Source/VERSION	(revision 49)
@@ -1,1 +1,1 @@
-1.1a2
+1.1a3