Index: trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser
===================================================================
--- trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 61)
+++ trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 63)
@@ -22,133 +22,5 @@
 		);
 		perUserDictionary = {
-			PBXPerProjectTemplateStateSaveDate = 63549866;
-			"PBXTemplateGeometry-F5314676015831810DCA290F" = {
-				ContentSize = "{769, 299}";
-				LeftSlideOut = {
-					Collapsed = NO;
-					Frame = "{{0, 23}, {769, 276}}";
-					Split0 = {
-						ActiveTab = 2;
-						ActiveTabName = PBXBuildResultsModule;
-						Collapsed = NO;
-						Frame = "{{0, 0}, {769, 276}}";
-						Split0 = {
-							Frame = "{{0, 129}, {769, 147}}";
-						};
-						SplitCount = 1;
-						Tab0 = {
-							Frame = "{{0, 0}, {952, 321}}";
-						};
-						Tab1 = {
-							Debugger = {
-								Collapsed = NO;
-								Frame = "{{0, 0}, {781, 452}}";
-								Split0 = {
-									Frame = "{{0, 24}, {781, 428}}";
-									Split0 = {
-										Frame = "{{0, 0}, {383, 428}}";
-									};
-									Split1 = {
-										DebugVariablesTableConfiguration = (
-											Name,
-											123,
-											Value,
-											85,
-											Summary,
-											155.123,
-										);
-										Frame = "{{392, 0}, {389, 428}}";
-									};
-									SplitCount = 2;
-								};
-								SplitCount = 1;
-								Tab0 = {
-									Frame = "{{0, 0}, {100, 50}}";
-								};
-								Tab1 = {
-									Frame = "{{0, 0}, {100, 50}}";
-								};
-								TabCount = 2;
-								TabsVisible = YES;
-							};
-							Frame = "{{0, 0}, {781, 452}}";
-							LauncherConfigVersion = 7;
-						};
-						Tab2 = {
-							Frame = "{{0, 0}, {685, 215}}";
-							LauncherConfigVersion = 3;
-							Runner = {
-								Frame = "{{0, 0}, {685, 215}}";
-							};
-						};
-						Tab3 = {
-							BuildMessageFrame = "{{0, 0}, {771, 92}}";
-							BuildTranscriptFrame = "{{0, 101}, {771, 0}}";
-							BuildTranscriptFrameExpanded = YES;
-							Frame = "{{0, 0}, {769, 123}}";
-						};
-						Tab4 = {
-							Frame = "{{0, 0}, {612, 295}}";
-						};
-						TabCount = 5;
-						TabsVisible = NO;
-					};
-					SplitCount = 1;
-					Tab0 = {
-						Frame = "{{0, 0}, {300, 533}}";
-						GroupTreeTableConfiguration = (
-							TargetStatusColumn,
-							18,
-							MainColumn,
-							267,
-						);
-					};
-					Tab1 = {
-						ClassesFrame = "{{0, 0}, {280, 398}}";
-						ClassesTreeTableConfiguration = (
-							PBXBookColumnIdentifier,
-							20,
-							PBXClassColumnIdentifier,
-							237,
-						);
-						Frame = "{{0, 0}, {278, 659}}";
-						MembersFrame = "{{0, 407}, {280, 252}}";
-						MembersTreeTableConfiguration = (
-							PBXBookColumnIdentifier,
-							20,
-							PBXMethodColumnIdentifier,
-							236,
-						);
-					};
-					Tab2 = {
-						Frame = "{{0, 0}, {200, 100}}";
-					};
-					Tab3 = {
-						Frame = "{{0, 0}, {200, 100}}";
-						TargetTableConfiguration = (
-							ActiveObject,
-							16,
-							ObjectNames,
-							202.296,
-						);
-					};
-					Tab4 = {
-						BreakpointsTreeTableConfiguration = (
-							breakpointColumn,
-							197,
-							enabledColumn,
-							31,
-						);
-						Frame = "{{0, 0}, {250, 100}}";
-					};
-					TabCount = 5;
-					TabsVisible = NO;
-				};
-				NavBarShownByDefault = YES;
-				StatusViewVisible = YES;
-				Template = F5314676015831810DCA290F;
-				ToolbarVisible = YES;
-				WindowLocation = "{509, 0}";
-			};
+			PBXPerProjectTemplateStateSaveDate = 63613638;
 			PBXWorkspaceContents = (
 				{
@@ -157,5 +29,5 @@
 							Split0 = {
 								NavContent0 = {
-									bookmark = E1F4C96603C9B1E6001509F3;
+									bookmark = E1F4C96D03CAAF8F001509F3;
 									history = (
 										E1D2937503BD418200F9204E,
@@ -254,6 +126,6 @@
 										E1C6414503C9AC4B001509F3,
 										E1F4C96203C9B1E6001509F3,
+										E1F4C96B03CAAF8F001509F3,
 										E1F4C96303C9B1E6001509F3,
-										E1AFB0CE03C9A59C001509F3,
 									);
 									prevStack = (
@@ -616,4 +488,5 @@
 										E1F4C96403C9B1E6001509F3,
 										E1F4C96503C9B1E6001509F3,
+										E1F4C96C03CAAF8F001509F3,
 									);
 								};
@@ -814,5 +687,5 @@
 					Template = 64ABBB4501FA494900185B06;
 					ToolbarVisible = YES;
-					WindowLocation = "{15, 277}";
+					WindowLocation = "{17, 110}";
 				},
 				{
@@ -945,5 +818,5 @@
 				},
 			);
-			PBXWorkspaceStateSaveDate = 63549866;
+			PBXWorkspaceStateSaveDate = 63613638;
 		};
 		perUserProjectItems = {
@@ -1208,5 +1081,4 @@
 			E1A9DF0703BF480F0089E8B2 = E1A9DF0703BF480F0089E8B2;
 			E1A9DF0803BF480F0089E8B2 = E1A9DF0803BF480F0089E8B2;
-			E1AFB0CE03C9A59C001509F3 = E1AFB0CE03C9A59C001509F3;
 			E1AFB0D103C9A59C001509F3 = E1AFB0D103C9A59C001509F3;
 			E1AFB0D203C9A59C001509F3 = E1AFB0D203C9A59C001509F3;
@@ -1402,5 +1274,7 @@
 			E1F4C96403C9B1E6001509F3 = E1F4C96403C9B1E6001509F3;
 			E1F4C96503C9B1E6001509F3 = E1F4C96503C9B1E6001509F3;
-			E1F4C96603C9B1E6001509F3 = E1F4C96603C9B1E6001509F3;
+			E1F4C96B03CAAF8F001509F3 = E1F4C96B03CAAF8F001509F3;
+			E1F4C96C03CAAF8F001509F3 = E1F4C96C03CAAF8F001509F3;
+			E1F4C96D03CAAF8F001509F3 = E1F4C96D03CAAF8F001509F3;
 			E1FCECFD03C972CF001509F3 = E1FCECFD03C972CF001509F3;
 		};
@@ -4319,14 +4193,4 @@
 		refType = 0;
 	};
-	E1AFB0CE03C9A59C001509F3 = {
-		fRef = 089C165DFE840E0CC02AAC07;
-		isa = PBXTextBookmark;
-		name = "English: 7";
-		rLen = 0;
-		rLoc = 226;
-		rType = 0;
-		vrLen = 223;
-		vrLoc = 0;
-	};
 	E1AFB0D103C9A59C001509F3 = {
 		fRef = E1A18CAC03B4344C00000028;
@@ -4458,5 +4322,5 @@
 		name = "English: 7";
 		rLen = 0;
-		rLoc = 226;
+		rLoc = 229;
 		rType = 0;
 		vrLen = 223;
@@ -6363,4 +6227,42 @@
 	};
 	E1F4C96303C9B1E6001509F3 = {
+		isa = PBXTargetBookmark;
+		trg = 29B97326FDCFA39411CA2CEA;
+	};
+	E1F4C96403C9B1E6001509F3 = {
+		fRef = E1BF6E9103C928D200050002;
+		isa = PBXTextBookmark;
+		name = "PSTimer.m: 176";
+		rLen = 0;
+		rLoc = 5239;
+		rType = 0;
+		vrLen = 641;
+		vrLoc = 5143;
+	};
+	E1F4C96503C9B1E6001509F3 = {
+		isa = PBXTargetBookmark;
+		trg = 29B97326FDCFA39411CA2CEA;
+	};
+	E1F4C96B03CAAF8F001509F3 = {
+		fRef = 089C165DFE840E0CC02AAC07;
+		isa = PBXTextBookmark;
+		name = "English: 7";
+		rLen = 0;
+		rLoc = 229;
+		rType = 0;
+		vrLen = 229;
+		vrLoc = 0;
+	};
+	E1F4C96C03CAAF8F001509F3 = {
+		fRef = 089C165DFE840E0CC02AAC07;
+		isa = PBXTextBookmark;
+		name = "English: 7";
+		rLen = 0;
+		rLoc = 229;
+		rType = 0;
+		vrLen = 229;
+		vrLoc = 0;
+	};
+	E1F4C96D03CAAF8F001509F3 = {
 		isa = PBXTargetBookmark;
 		trg = 29B97326FDCFA39411CA2CEA;
@@ -6379,42 +6281,4 @@
 			);
 		};
-	};
-	E1F4C96403C9B1E6001509F3 = {
-		fRef = E1BF6E9103C928D200050002;
-		isa = PBXTextBookmark;
-		name = "PSTimer.m: 176";
-		rLen = 0;
-		rLoc = 5239;
-		rType = 0;
-		vrLen = 641;
-		vrLoc = 5143;
-	};
-	E1F4C96503C9B1E6001509F3 = {
-		isa = PBXTargetBookmark;
-		trg = 29B97326FDCFA39411CA2CEA;
-		uiCtxt = {
-			TOCViewDetailVisibleRect = "{{0, 0}, {467, 581}}";
-			TOCViewExpandedItems = (
-				"com.apple.target-editor-pane.settings",
-				"com.apple.target-editor-pane.settings.simple",
-				"com.apple.target-editor-pane.info-plist",
-				"com.apple.target-editor-pane.info-plist.simple",
-				"com.apple.target-editor-pane.buildphases",
-			);
-			TOCViewMasterVisibleRect = "{{0, 0}, {183, 581}}";
-			TOCViewSelectedItems = (
-				"com.apple.target-editor-pane.info-plist",
-			);
-		};
-	};
-	E1F4C96603C9B1E6001509F3 = {
-		fRef = 089C165DFE840E0CC02AAC07;
-		isa = PBXTextBookmark;
-		name = "English: 5";
-		rLen = 0;
-		rLoc = 156;
-		rType = 0;
-		vrLen = 226;
-		vrLoc = 0;
 	};
 	E1FCECFD03C972CF001509F3 = {