Index: /trunk/Cocoa/Pester/Source/PSAlarms.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 63)
+++ /trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 64)
@@ -37,4 +37,5 @@
 + (void)setUp;
 {
+    [PSTimer setUp];
     if (PSAlarmsAllAlarms == nil) {
         NSDictionary *plAlarms = [[NSUserDefaults standardUserDefaults] objectForKey: PSAllAlarms];
@@ -45,5 +46,4 @@
         }
         [PSAlarmsAllAlarms _updateNextAlarm]; // only generate notifications after singleton established
-        [PSTimer setUp];
     }
 }
Index: /trunk/Cocoa/Pester/Source/PSTimer.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSTimer.m	(revision 63)
+++ /trunk/Cocoa/Pester/Source/PSTimer.m	(revision 64)
@@ -106,6 +106,8 @@
 - (void)_invalidate;
 {
-    isValid = NO;
-    [[self class] _timerDeleted: self];
+    if (isValid) {
+        isValid = NO;
+        [[self class] _timerDeleted: self];
+    }
 }
 
@@ -218,11 +220,11 @@
     if (PSTimerOnWake != nil) {
         NSDate *date = [PSTimerOnWake fireDate];
-        NSLog(@"%lf sec remain until alarm", [date timeIntervalSinceNow]);
+        // NSLog(@"%lf sec remain until alarm", [date timeIntervalSinceNow]);
         if ([date timeIntervalSinceNow] > 30) {
-            NSLog(@"going to sleep, setting timer %@", PSTimerOnWake);
+            // NSLog(@"going to sleep, setting timer %@", PSTimerOnWake);
             [PSPowerManager setWakeTime: [[PSTimerOnWake fireDate] addTimeInterval: -15]];
             return YES;
         } else {
-            NSLog(@"not setting timer, will attempt to prevent idle sleep");
+            // NSLog(@"not setting timer, will attempt to prevent idle sleep");
             return NO;
         }
Index: /trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser
===================================================================
--- /trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 63)
+++ /trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 64)
@@ -22,5 +22,133 @@
 		);
 		perUserDictionary = {
-			PBXPerProjectTemplateStateSaveDate = 63613638;
+			PBXPerProjectTemplateStateSaveDate = 63616518;
+			"PBXTemplateGeometry-64ABBB4501FA494900185B06" = {
+				ContentSize = "{968, 658}";
+				LeftSlideOut = {
+					ActiveTab = 0;
+					ActiveTabName = PBXGroupTreeModule;
+					Collapsed = NO;
+					Frame = "{{0, 23}, {968, 635}}";
+					Split0 = {
+						Collapsed = NO;
+						Frame = "{{279, 0}, {689, 635}}";
+						Split0 = {
+							Frame = "{{0, 0}, {689, 635}}";
+						};
+						SplitCount = 1;
+						Tab0 = {
+							Frame = "{{0, 0}, {681, 289}}";
+						};
+						Tab1 = {
+							Debugger = {
+								Collapsed = NO;
+								Frame = "{{0, 0}, {681, 150}}";
+								Split0 = {
+									Frame = "{{0, 24}, {681, 126}}";
+									Split0 = {
+										Frame = "{{0, 0}, {333, 126}}";
+									};
+									Split1 = {
+										DebugVariablesTableConfiguration = (
+											Name,
+											123,
+											Value,
+											85,
+											Summary,
+											105.123,
+										);
+										Frame = "{{342, 0}, {339, 126}}";
+									};
+									SplitCount = 2;
+								};
+								SplitCount = 1;
+								Tab0 = {
+									Frame = "{{0, 0}, {100, 50}}";
+								};
+								Tab1 = {
+									Frame = "{{0, 0}, {100, 50}}";
+								};
+								TabCount = 2;
+								TabsVisible = YES;
+							};
+							Frame = "{{0, 0}, {681, 120}}";
+							LauncherConfigVersion = 7;
+						};
+						Tab2 = {
+							Frame = "{{0, 0}, {681, 234}}";
+							LauncherConfigVersion = 3;
+							Runner = {
+								Frame = "{{0, 0}, {681, 234}}";
+							};
+						};
+						Tab3 = {
+							BuildMessageFrame = "{{0, 0}, {683, 205}}";
+							BuildTranscriptFrame = "{{0, 214}, {683, 2}}";
+							BuildTranscriptFrameExpanded = YES;
+							Frame = "{{0, 0}, {681, 238}}";
+						};
+						Tab4 = {
+							Frame = "{{0, 0}, {612, 295}}";
+						};
+						TabCount = 5;
+						TabsVisible = NO;
+					};
+					SplitCount = 1;
+					Tab0 = {
+						Frame = "{{0, 0}, {255, 635}}";
+						GroupTreeTableConfiguration = (
+							TargetStatusColumn,
+							18,
+							MainColumn,
+							222,
+						);
+					};
+					Tab1 = {
+						ClassesFrame = "{{0, 0}, {235, 381}}";
+						ClassesTreeTableConfiguration = (
+							PBXBookColumnIdentifier,
+							20,
+							PBXClassColumnIdentifier,
+							192,
+						);
+						Frame = "{{0, 0}, {233, 635}}";
+						MembersFrame = "{{0, 390}, {235, 245}}";
+						MembersTreeTableConfiguration = (
+							PBXBookColumnIdentifier,
+							20,
+							PBXMethodColumnIdentifier,
+							191,
+						);
+					};
+					Tab2 = {
+						Frame = "{{0, 0}, {217, 635}}";
+					};
+					Tab3 = {
+						Frame = "{{0, 0}, {239, 554}}";
+						TargetTableConfiguration = (
+							ActiveObject,
+							16,
+							ObjectNames,
+							206.296,
+						);
+					};
+					Tab4 = {
+						BreakpointsTreeTableConfiguration = (
+							breakpointColumn,
+							197,
+							enabledColumn,
+							31,
+						);
+						Frame = "{{0, 0}, {250, 635}}";
+					};
+					TabCount = 5;
+					TabsVisible = YES;
+				};
+				NavBarShownByDefault = YES;
+				StatusViewVisible = YES;
+				Template = 64ABBB4501FA494900185B06;
+				ToolbarVisible = YES;
+				WindowLocation = "{12, 455}";
+			};
 			PBXWorkspaceContents = (
 				{
@@ -818,5 +946,5 @@
 				},
 			);
-			PBXWorkspaceStateSaveDate = 63613638;
+			PBXWorkspaceStateSaveDate = 63616518;
 		};
 		perUserProjectItems = {
@@ -1546,5 +1674,5 @@
 		name = "PSAlarms.m: ";
 		rLen = 0;
-		rLoc = 4481;
+		rLoc = 4477;
 		rType = 0;
 		vrLen = 1348;
@@ -1596,5 +1724,5 @@
 		name = "PSAlarms.m: 244";
 		rLen = 0;
-		rLoc = 7719;
+		rLoc = 7715;
 		rType = 0;
 		vrLen = 1412;
@@ -2127,5 +2255,5 @@
 		name = "PSAlarms.m: 205";
 		rLen = 0;
-		rLoc = 6053;
+		rLoc = 6049;
 		rType = 0;
 		vrLen = 1441;
@@ -2537,5 +2665,5 @@
 		name = "PSAlarms.m: allAlarms";
 		rLen = 0;
-		rLoc = 4481;
+		rLoc = 4477;
 		rType = 0;
 		vrLen = 1234;
@@ -3004,5 +3132,5 @@
 		name = "PSAlarms.m: 93";
 		rLen = 0;
-		rLoc = 2808;
+		rLoc = 2804;
 		rType = 0;
 		vrLen = 1387;
@@ -3264,5 +3392,5 @@
 		name = "PSAlarms.m: alarm";
 		rLen = 0;
-		rLoc = 4481;
+		rLoc = 4477;
 		rType = 0;
 		vrLen = 1292;
@@ -3284,5 +3412,5 @@
 		name = "PSAlarms.m: init";
 		rLen = 0;
-		rLoc = 4208;
+		rLoc = 4204;
 		rType = 0;
 		vrLen = 1554;
@@ -3304,5 +3432,5 @@
 		name = "PSAlarms.m: init";
 		rLen = 0;
-		rLoc = 4208;
+		rLoc = 4204;
 		rType = 0;
 		vrLen = 1554;
@@ -3324,5 +3452,5 @@
 		name = "PSAlarms.m: dealloc";
 		rLen = 0;
-		rLoc = 4392;
+		rLoc = 4388;
 		rType = 0;
 		vrLen = 1581;
@@ -3354,5 +3482,5 @@
 		name = "PSAlarms.m: _alarmDied:";
 		rLen = 0;
-		rLoc = 4481;
+		rLoc = 4477;
 		rType = 0;
 		vrLen = 1278;
@@ -3523,5 +3651,5 @@
 		name = "PSAlarms.m: alarm";
 		rLen = 0;
-		rLoc = 4481;
+		rLoc = 4477;
 		rType = 0;
 		vrLen = 1228;
@@ -3543,5 +3671,5 @@
 		name = "PSAlarms.m: 169";
 		rLen = 11;
-		rLoc = 4825;
+		rLoc = 4821;
 		rType = 0;
 		vrLen = 1022;
@@ -3843,5 +3971,5 @@
 		name = "PSAlarms.m: 169";
 		rLen = 11;
-		rLoc = 4825;
+		rLoc = 4821;
 		rType = 0;
 		vrLen = 1007;
@@ -4238,5 +4366,5 @@
 		name = "PSAlarms.m: 86";
 		rLen = 0;
-		rLoc = 2679;
+		rLoc = 2675;
 		rType = 0;
 		vrLen = 1369;
@@ -4416,5 +4544,5 @@
 		name = "PSTimer.m: 181";
 		rLen = 18;
-		rLoc = 5369;
+		rLoc = 5402;
 		rType = 0;
 		vrLen = 708;
@@ -4436,5 +4564,5 @@
 		name = "PSTimer.m: 186";
 		rLen = 32;
-		rLoc = 5413;
+		rLoc = 5446;
 		rType = 0;
 		vrLen = 682;
@@ -4456,5 +4584,5 @@
 		name = "PSTimer.m: ";
 		rLen = 0;
-		rLoc = 5445;
+		rLoc = 5478;
 		rType = 0;
 		vrLen = 682;
@@ -4616,5 +4744,5 @@
 		name = "PSAlarms.m: 86";
 		rLen = 0;
-		rLoc = 2679;
+		rLoc = 2675;
 		rType = 0;
 		vrLen = 1369;
@@ -4656,5 +4784,5 @@
 		name = "PSTimer.m: setWakeUp:";
 		rLen = 9;
-		rLoc = 5421;
+		rLoc = 5454;
 		rType = 0;
 		vrLen = 690;
@@ -4696,5 +4824,5 @@
 		name = "PSTimer.m: ";
 		rLen = 0;
-		rLoc = 6624;
+		rLoc = 6666;
 		rType = 0;
 		vrLen = 1086;
@@ -4716,5 +4844,5 @@
 		name = "PSTimer.m: 147";
 		rLen = 0;
-		rLoc = 4576;
+		rLoc = 4609;
 		rType = 0;
 		vrLen = 1062;
@@ -4746,5 +4874,5 @@
 		name = "PSTimer.m: powerManagerShouldSleep:";
 		rLen = 0;
-		rLoc = 5841;
+		rLoc = 5874;
 		rType = 0;
 		vrLen = 1062;
@@ -4896,5 +5024,5 @@
 		name = "PSAlarms.m: 206";
 		rLen = 0;
-		rLoc = 6053;
+		rLoc = 6049;
 		rType = 0;
 		vrLen = 1340;
@@ -4926,5 +5054,5 @@
 		name = "PSAlarms.m: 48";
 		rLen = 0;
-		rLoc = 1413;
+		rLoc = 1409;
 		rType = 0;
 		vrLen = 1406;
@@ -5104,5 +5232,5 @@
 		name = "PSTimer.m: 217";
 		rLen = 0;
-		rLoc = 5931;
+		rLoc = 5964;
 		rType = 0;
 		vrLen = 1138;
@@ -5124,5 +5252,5 @@
 		name = "PSTimer.m: 217";
 		rLen = 0;
-		rLoc = 5931;
+		rLoc = 5964;
 		rType = 0;
 		vrLen = 1138;
@@ -5144,5 +5272,5 @@
 		name = "PSTimer.m: 224";
 		rLen = 0;
-		rLoc = 6333;
+		rLoc = 6372;
 		rType = 0;
 		vrLen = 1092;
@@ -6043,5 +6171,5 @@
 		name = "PSAlarms.m: setUp";
 		rLen = 0;
-		rLoc = 1190;
+		rLoc = 1211;
 		rType = 0;
 		vrLen = 1371;
@@ -6221,5 +6349,5 @@
 		name = "PSTimer.m: 176";
 		rLen = 0;
-		rLoc = 5239;
+		rLoc = 5273;
 		rType = 0;
 		vrLen = 641;
@@ -6235,5 +6363,5 @@
 		name = "PSTimer.m: 176";
 		rLen = 0;
-		rLoc = 5239;
+		rLoc = 5273;
 		rType = 0;
 		vrLen = 641;
@@ -6267,18 +6395,4 @@
 		isa = PBXTargetBookmark;
 		trg = 29B97326FDCFA39411CA2CEA;
-		uiCtxt = {
-			TOCViewDetailVisibleRect = "{{0, 0}, {467, 581}}";
-			TOCViewExpandedItems = (
-				"com.apple.target-editor-pane.settings",
-				"com.apple.target-editor-pane.settings.simple",
-				"com.apple.target-editor-pane.info-plist",
-				"com.apple.target-editor-pane.info-plist.simple",
-				"com.apple.target-editor-pane.buildphases",
-			);
-			TOCViewMasterVisibleRect = "{{0, 0}, {183, 581}}";
-			TOCViewSelectedItems = (
-				"com.apple.target-editor-pane.info-plist",
-			);
-		};
 	};
 	E1FCECFD03C972CF001509F3 = {
Index: /trunk/Cocoa/Pester/Source/VERSION
===================================================================
--- /trunk/Cocoa/Pester/Source/VERSION	(revision 63)
+++ /trunk/Cocoa/Pester/Source/VERSION	(revision 64)
@@ -1,1 +1,1 @@
-1.1b1
+1.1b2